AbstractRevisionItem subclass:#SourceRevisionItem
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Browsers'
!


!SourceRevisionItem methodsFor:'accessing'!

sourceStream
"
<return: ReadStream>
"                     
    ^self parent myClass currentSourceStream readStream
! !

!SourceRevisionItem methodsFor:'protocol'!

icon

    ^#loadedRevision

!

revisionString
    "return the value of the instance variable 'revision' (automatically generated)"

    ^ revision isNil
        ifTrue: ['no revision']
        ifFalse:['current (based on:',(revision at:#revision),')']

! !

!SourceRevisionItem methodsFor:'testing'!

basedOnActualRevision
"
returns if the changes of the class are based on the actual revision of the class

<return: Boolean>
"
     revision ifNil:[^true].
     ^parent newestRevision = (revision at:#revision)
!

hasSourceStream
"
has the receiver a source stream? Used for testing tree items.

<return: Boolean>
"
    ^true


!

isLoadedRevision
"
the receiver is always the actual revision of a class, hence isloadedRevision
must be true.

<return: Boolean>
"

    ^true


! !

!SourceRevisionItem class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libtool/SourceRevisionItem.st,v 1.2 2000-01-14 10:51:35 ps Exp $'
! !
